# yTvz
#     TvvOC
#     wACewNGXgłATꏊw肷邱Ƃł
# yӎz
#     quest_private.pl̃Tu[`͓ǂݍ܂ĂȂƂ̂Ŋ{Iɂ͎gpȂ

package Quest::Plugin::sample_find_item; # pbP[W̖͊gqt@CƓƂ

use strict; # Xy~XȂǂt₷邽ߊ{Iuse
use quest_const; # NGXg֘A̒萔gp邽ߊ{Iuse

#### ݒ荀 ####

my @placeList = (); # IłTꏊiTꏊ𖳎ꍇ͋̔zj

#### ܂Őݒ荀 ####

# NGXg֘A
my $quest_name = 'TTv'; # NGXg

# 쌠\֘A
my $copyright_name = $quest_name; # 앨i{IɃNGXgƓj
my $copyright_ver = '1.0.1'; # o[W
my $copyright_year = '2011'; # N
my $copyright_url = 'http://www11.big.or.jp/~hazymoon/index.htm'; # URL
my $copyright_holder = 'moon'; # 쌠

# NGXgf[^֘A
my $quest_key_place = 'place'; # Tꏊ\L[
my $quest_key_item = 'item'; # ACe\L[
my $quest_key_itemnum = 'itemnum'; # \L[

# ݒ֘A
my $trade_key_place = $quest_key_place; # Tꏊ\L[
my $trade_key_item = $quest_key_item; # ACe\L[
my $trade_key_itemnum = $quest_key_itemnum; # \L[

# ݒf[^^Cv֘A
my %config_type_hash = (
	$quest_key_place => Quest::TYPE_FLAG_RANDOM, # z܂̓nbV
	$quest_key_item => Quest::TYPE_FLAG_RANDOM, # z܂̓nbV
	$quest_key_itemnum => Quest::TYPE_FLAG_RANDOM, # z܂̓nbV
); # ݒf[^^Cv̒`

# NGXg擾ۂɌĂ΂鏈
#     yz
#         Ȃ
#     y߂lz
#         'NGXg'
sub _name{
	# NGXg߂
	return $quest_name;
}

# 쌠擾ۂɌĂ΂鏈
#     yz
#         Ȃ
#     y߂lz
#         '쌠'
sub _copyright{
	# 쌠\
	return sprintf(Quest::COPYRIGHT_LINK_FORMAT, $copyright_name, $copyright_ver, $copyright_year, $copyright_url, $copyright_holder);
}

# T|[gĂ邩ǂ擾ۂɌĂ΂鏈
#     yz
#         NGXgCũW[o[W
#         NGXgCũ}Ci[o[W
#     y߂lz
#         T|[gĂȂ^AȊO͋U
sub _support{
	my $majorVer = shift;
	my $minorVer = shift;

	# Ver.1.*T|[g
	return $majorVer == 1;
}

# ݒf[^^Cv擾ۂɌĂ΂鏈
#     yz
#         Ȃ
#     y߂lz
#         {"ݒL[1"=>f[^^CvtO,EEE,"ݒL[n"=>f[^^CvtO}
sub _type{
	return \%config_type_hash;
}

# NGXg쐬ۂɌĂ΂鏈
#     yz
#         ݒ̃nbVt@X
#         {ݒς݃NGXgf[^̃nbVt@X
#     y߂lz
#         Ȃ
sub _setup{
	my $configHashRef = shift;
	my $questHashRef = shift;

	# G[bZ[WpɎʂȂǂ擾
	my $kind = &Quest::get_kind($questHashRef);
	my $rank = int(&Quest::get_rank($questHashRef));
	my $errFormat = 'NGXgݒ肪ԈĂ܂Bi=%sAN=%dA%sj';
	# NGXgf[^ɒTꏊAACeA̏ݒ肷
	$questHashRef->{$quest_key_place} = @placeList ? &Quest::get_random_elem($configHashRef->{$quest_key_place}, sprintf($errFormat, $kind, $rank, 'Tꏊ')) : '';
	$questHashRef->{$quest_key_item} = &Quest::get_random_elem($configHashRef->{$quest_key_item}, sprintf($errFormat, $kind, $rank, 'ACe'));
	$questHashRef->{$quest_key_itemnum} = &Quest::get_random_elem($configHashRef->{$quest_key_itemnum}, sprintf($errFormat, $kind, $rank, ''));
}

# B擾ۂɌĂ΂鏈
#     yz
#         NGXgf[^̃nbVt@X
#     y߂lz
#         'B'
sub _todo{
	my $questHashRef = shift;

	my $place = $questHashRef->{$quest_key_place};
	my $item = $questHashRef->{$quest_key_item};
	my $itemnum = int($questHashRef->{$quest_key_itemnum});
	return sprintf('%sTăACe <span style="font-weight: bold;">%s</span>  <span style="font-weight: bold;">%d</span> BȂAACe͓łȂB', $place ne '' ? sprintf('Tꏊ <span style="font-weight: bold;">%s</span> ', $place) : '', $item, $itemnum);
}

# oߕ擾ۂɌĂ΂鏈
#     yz
#         NGXgf[^̃nbVt@X
#     y߂lz
#         'oߕ'
sub _progress{
	my $questHashRef = shift;

	my $itemnum = int($questHashRef->{$quest_key_itemnum});
	my $current = int(&Quest::get_progress($questHashRef, Quest::TYPE_FLAG_SCALAR));
	return sprintf('%dς݁ic%dj', $current, $current < $itemnum ? $itemnum - $current : 0);
}

# sۂɌĂ΂鏈
#     yz
#         NGXgf[^̃nbVt@X
#         [p[^1,EEE,p[^n]
#     y߂lz
#         sȂ^AȊO͋U
#     y⑫z
#         ؂ꂨђBς݂̏ꍇ͌Ă΂Ȃ
sub _action{
	my $questHashRef = shift;
	my $paramListRef = shift;

	# ݂̍s̒TꏊƃACe擾ip[^[Xg1ڂTꏊ2ڂACeƂĂj
	my $currentPlace = $paramListRef->[0];
	my $currentItem = $paramListRef->[1];
	# TꏊƃACȅNGXgf[^擾
	my $place = $questHashRef->{$quest_key_place};
	my $item = $questHashRef->{$quest_key_item};
	# TꏊƃACevꍇ͐^AȊO͋U߂iTꏊ̏ꍇ͒Tꏊ͖Ăj
	if(($place eq '' || $currentPlace eq $place) && $currentItem eq $item){
		# NGXgo߂ɔς݌ݒ肷
		&Quest::set_progress($questHashRef, &Quest::get_progress($questHashRef, Quest::TYPE_FLAG_SCALAR) + 1);
		# bZ[W\
		&Quest::message(sprintf('ړĨACeu%sv𔭌߃NGXǧo߂XV܂F %s', $item, &_progress($questHashRef)));
		# ssꂽ̂Ő^߂
		return 1;
	}
	# ssȂ̂ŋU߂
	return 0;
}

# B̔茋ʂ擾ۂɌĂ΂鏈
#     yz
#         NGXgf[^̃nbVt@X
#     y߂lz
#         B𖞂ĂȂ^AȊO͋U
sub _judge{
	my $questHashRef = shift;

	# ̏Ɣς݌擾
	my $itemnum = int($questHashRef->{$quest_key_itemnum});
	my $current = int(&Quest::get_progress($questHashRef, Quest::TYPE_FLAG_SCALAR));
	# ݂̌̏𖞂Ă邩ǂ߂
	return $current >= $itemnum;
}

# ݒsۂɌĂ΂鏈
#     yz
#         [h
#         ݂̌̃nbVt@X
#         G[bZ[WZbgz񃊃t@X
#     y߂lz
#         [hɂقȂ
#             PLUGIN_CONFIG_MODE_SUPPORTF ƎݒT|[gĂꍇ͐^AȊO͋U
#             PLUGIN_CONFIG_MODE_FORMF CӁij
#             PLUGIN_CONFIG_MODE_SETF ݒ肪OK̏ꍇ͐ݒL[L[Ƃݒl̃nbVt@XAȊOundef
#             PLUGIN_CONFIG_MODE_TEXTF [[ݒ薼1,ݒl1],EEE,[ݒ薼n,ݒln]]
sub _config{
	my $mode = shift;
	my $tradeHashRef = shift;
	my $msgListRef = shift;

	if($mode eq Quest::PLUGIN_CONFIG_MODE_SUPPORT){
		return 1;
	}
	elsif($mode eq Quest::PLUGIN_CONFIG_MODE_FORM){
		# ͒lꍇ͓͒lgpAȊO͐ݒς݂̒lgp
		my $tradePlace = exists($main::Fm{$trade_key_place}) ? $main::Fm{$trade_key_place} : $tradeHashRef->{$trade_key_place};
		my $tradeItem = exists($main::Fm{$trade_key_item}) ? $main::Fm{$trade_key_item} : $tradeHashRef->{$trade_key_item};
		my $tradeItemNum = exists($main::Fm{$trade_key_itemnum}) ? $main::Fm{$trade_key_itemnum} : $tradeHashRef->{$trade_key_itemnum};
		if(@placeList){
			print '<tr>';
			print '<td>TꏊF</td>';
			print '<td><select name="', $trade_key_place, '">';
			print '<option value=""', $tradePlace eq '' ? ' selected' : '', '></option>';
			foreach my $place (@placeList){
				print '<option value="', $place, '"', $place eq $tradePlace ? ' selected' : '', '>', $place, '</option>';
			}
			print '</select></td>';
			print '</tr>';
		}
		print '<tr>';
		print '<td>TACeF</td>';
		print '<td>';
		&main::input('text', $trade_key_item, $tradeItem, sprintf(' size="%d"', Quest::TEXTBOX_SIZE_LARGE), '');
		print '</td>';
		print '</tr>';
		print '<tr>';
		print '<td>TACe̍ő吔F</td>';
		print '<td>';
		&main::input('text', $trade_key_itemnum, $tradeItemNum, sprintf(' size="%d"', Quest::TEXTBOX_SIZE_SMALL), '');
		print '</td>';
		print '</tr>';
	}
	elsif($mode eq Quest::PLUGIN_CONFIG_MODE_SET){
		# ͒lgp
		my $tradePlace = $main::Fm{$trade_key_place};
		my $tradeItem = $main::Fm{$trade_key_item};
		my $tradeItemNum = $main::Fm{$trade_key_itemnum};
		my %hash = ();
		my $ret = \%hash;
		if(@placeList && $tradePlace ne ''){
			my $isFound = 0;
			foreach my $place (@placeList){
				if($place eq $tradePlace){
					$isFound = 1;
					last;
				}
			}
			if($isFound){
				$hash{$trade_key_place} = $tradePlace;
			}
			else{
				undef($ret);
				push(@$msgListRef, 'Tꏊw肷ꍇ݂͑TꏊIĂB');
			}
		}
		if($tradeItem ne ''){
			if(length($tradeItem) <= Quest::MAX_INPUT_SIZE){
				$hash{$trade_key_item} = $tradeItem;
			}
			else{
				undef($ret);
				push(@$msgListRef, 'TACe̎w肪܂B');
			}
		}
		if($tradeItemNum ne ''){
			if(int($tradeItemNum) >= 1){
				$hash{$trade_key_itemnum} = int($tradeItemNum);
			}
			else{
				undef($ret);
				push(@$msgListRef, 'TACe̍ő吔w肷ꍇ 1 ȏ͂ĂB');
			}
		}
		return $ret;
	}
	elsif($mode eq Quest::PLUGIN_CONFIG_MODE_TEXT){
		# ݒς݂̒lgp
		my @list = ();
		push(@list, ['Tꏊ', $tradeHashRef->{$trade_key_place}]) if(@placeList && exists($tradeHashRef->{$trade_key_place}));
		push(@list, ['TACe', $tradeHashRef->{$trade_key_item}]) if(exists($tradeHashRef->{$trade_key_item}));
		push(@list, ['TACe̍ő吔', $tradeHashRef->{$trade_key_itemnum} . '']) if(exists($tradeHashRef->{$trade_key_itemnum}));
		return \@list;
	}
	return;
}

# 𖞂Ă邩ǂ擾鏈
#     yz
#         ̃nbVt@X
#         NGXgf[^̃nbVt@X
#         bZ[W̔z񃊃t@X
#     y߂lz
#         𖞂ĂȂ^AȊO͋U
sub _trade{
	my $tradeHashRef = shift;
	my $questHashRef = shift;
	my $msgListRef = shift;

	my $isOK = 1;

	# Tꏊ̃`FbN
	if(@placeList && exists($tradeHashRef->{$trade_key_place}) && $questHashRef->{$quest_key_place} ne '' && $questHashRef->{$quest_key_place} ne $tradeHashRef->{$trade_key_place}){
		$isOK = 0;
		push(@$msgListRef, 'Tꏊ̏𖞂Ă܂B');
	}
	# TACẽ`FbN
	if(exists($tradeHashRef->{$trade_key_item}) && $questHashRef->{$quest_key_item} ne $tradeHashRef->{$trade_key_item}){
		$isOK = 0;
		push(@$msgListRef, 'TACȅ𖞂Ă܂B');
	}
	# TACe̍ő吔̃`FbN
	if(exists($tradeHashRef->{$trade_key_itemnum}) && int($questHashRef->{$quest_key_itemnum}) > int($tradeHashRef->{$trade_key_itemnum})){
		$isOK = 0;
		push(@$msgListRef, 'TACe̍ő吔̏𖞂Ă܂B');
	}

	return $isOK;
}
